/*

  WiFi UDP Send and Receive String

 This sketch wait an UDP packet on localPort using the WiFi module.

 When a packet is received an Acknowledge packet is sent to the client on port remotePort

 created 30 December 2012

 by dlf (Metodo2 srl)

 */

#include <SPI.h>
#include <WiFiNINA.h>
#include <WiFiUdp.h>
#include <SparkFun_TB6612.h>
#include <Wire.h>

//driver 1
#define PWMA 3
#define PWMB 4
#define AIN1 0
#define AIN2 1
#define BIN1 2
#define BIN2 7

//driver 2
#define PWMC 5
#define PWMD 6
#define CIN1 8
#define CIN2 9
#define DIN1 10
#define DIN2 11

#define STBY 12
#define NMOTORS 4

const int offsetA = 1;
const int offsetB = 1;
const int offsetC = 1;
const int offsetD = 1;
const int sp = 255;
const int tim = 1;

Motor motor1 = Motor(AIN1, AIN2, PWMA, offsetA, STBY);
Motor motor2 = Motor(BIN1, BIN2, PWMB, offsetB, STBY);
Motor motor3 = Motor(CIN1, CIN2, PWMC, offsetC, STBY);
Motor motor4 = Motor(DIN1, DIN2, PWMD, offsetD, STBY);

Motor motors[NMOTORS] = {motor1, motor2, motor3, motor4};

String command0[] = {"forward","255","1000"};
String command1[] = {"backward","255","1000"};
String command2[] = {"left","125","1000"};
String command3[] = {"right","125","1000"};
String command4[] = {"brake","0","1000"};

int status = WL_IDLE_STATUS;
///////please enter your sensitive data in the Secret tab/arduino_secrets.h
char ssid[] = "Hotspottest";        // your network SSID (name)
char pass[] = "bang5555";    // your network password (use for WPA, or use as key for WEP)
int keyIndex = 0;            // your network key Index number (needed only for WEP)

unsigned int localPort = 4000;      // local port to listen on

IPAddress server(172,20,10,8);

WiFiClient client;

char packetBuffer[256]; //buffer to hold incoming packet
char  ReplyBuffer[] = "acknowledged";       // a string to send back

//motor pins
//const byte motor1 = 13;
//const byte motor2 = 14;
//const byte motor3 = 15;
//const byte motor4 = 16;

WiFiUDP Udp;

void setup() {

  //Initialize serial and wait for port to open:

  Serial.begin(9600);

  Wire.begin();

  while (!Serial) {

    ; // wait for serial port to connect. Needed for native USB port only

  }

  // check for the WiFi module:

  if (WiFi.status() == WL_NO_MODULE) {

    Serial.println("Communication with WiFi module failed!");

    // don't continue

    while (true);

  }

  String fv = WiFi.firmwareVersion();

  if (fv < WIFI_FIRMWARE_LATEST_VERSION) {

    Serial.println("Please upgrade the firmware");

  }

  // attempt to connect to Wifi network:

  while (status != WL_CONNECTED) {

    Serial.print("Attempting to connect to SSID: ");

    Serial.println(ssid);

    // Connect to WPA/WPA2 network. Change this line if using open or WEP network:

    status = WiFi.begin(ssid, pass);

    // wait 10 seconds for connection:

    delay(10000);

  }

  Serial.println("Connected to wifi");

  printWifiStatus();

  Serial.println(server);
  while(!client.connect(server, localPort)){
    Serial.println("\nAttempting to connect to server...");
    if (client.connect(server, localPort)) {
      Serial.println("connected");
      // Make a HTTP request:
//      client.println("GET /cutup/1.php");
//      client.println();
    } 
    else {
      Serial.println("connection failed");
    }
  }
  
//
//  Serial.println("\nStarting connection to server...");
//
//  // if you get a connection, report back via serial:
//
//  Udp.begin(localPort);
}
int count = 0;
void loop() {
  count++;
  if(count>500){
    if (client.connect(server, localPort)) {
//      Serial.println("connected");
      // Make a HTTP request:
//      client.println("GET /cutup/1.php");
//      client.println();
      count=0;
    } 
    else {
      Serial.println("connection failed");
    }
  }
  
  // if there's data available, read a packet
//  Serial.print("hi");
//  int packetSize = Udp.parsePacket();
//
//  Serial.println(packetSize);


    client.write("Helloooooo");

  char c;

    
 
    if (client.available()) {
//      Serial.println("Client available");
      c = client.read();
      Serial.println(c);
    }
    else{
//      Serial.println("Not Available... kms");
    }
  

    if(count>500){
      client.stop();  
    }
    


    

    for(char x: packetBuffer1){
      if(c=='w'){
        //all forward
        forwardAll(sp,tim);
        }
      if(c=='s'){
        //all backward
        backAll(sp,tim);
        }
      if(c=='a'){
        //all left 2 backward right 2 forward
        leftAll(sp,tim);
        }
      if(c=='d'){
        //all left 2 forward right 2 backward
        rightAll(sp,tim);
        }
      if(c=='p'){
        //brake
        brakeAll(tim);
      }


  }


//hits the brakes on all motors
void brakeAll(int t){
  for(int i = 0; i < NMOTORS; i++){
    motors[i].brake();
  }
  delay(t);
}

//moves forward on all motors
void forwardAll(int sp, int t){
  forward(motors[0],motors[1],sp);  
  if(NMOTORS == 4) {
    forward(motors[2],motors[3],sp);  
  }
  delay(t);
}

//moves backward on all motors
void backAll(int sp, int t){
  back(motors[0],motors[1],sp);  
  if(NMOTORS == 4) {
    back(motors[2],motors[3],sp);  
  }
  delay(t);
}

//moves the rover left
void leftAll(int sp, int t){
  left(motors[0],motors[2],t);
  left(motors[1],motors[3],t);
  delay(t);  
}

//moves the rover right
void rightAll(int sp, int t){
  right(motors[0],motors[2],t);
  right(motors[1],motors[3],t);
  delay(t);
}

//moves the rover based on a string command
/*
 * --------------command = {function, power, time}--------------
 * 
 * function is "forward", "backward", "brake", "left" or "right"
 * power is a value between 1 and 255
 * time is the length of time the command will last in ms
 * -------------------------------------------------------------
 */
 
void move(String command[2]){
  String func = command[0];
  float power = command[1].toFloat();
  int t = command[2].toInt();
  if(func == "forward"){
    forwardAll(power,t);
  }
  else if(func == "backward"){
    backAll(power,t);
  }
  else if(func == "brake"){
    brakeAll(t);
  }
  else if(func == "left"){
    left(motor1,motor2,power);
    delay(t);
  }
  else if(func == "right"){
    right(motor1,motor2,power);
    delay(t);
  }
}

void printWifiStatus() {

  // print the SSID of the network you're attached to:

  Serial.print("SSID: ");

  Serial.println(WiFi.SSID());

  // print your board's IP address:

  IPAddress ip = WiFi.localIP();

  Serial.print("IP Address: ");

  Serial.println(ip);

  // print the received signal strength:

  long rssi = WiFi.RSSI();

  Serial.print("signal strength (RSSI):");

  Serial.print(rssi);

  Serial.println(" dBm");
}

void motorfunc(char packetBuff[256]){
  for(char x: packetBuff){
    if(x=='w'){
      //all forward
      
      }
    if(x=='s'){
      //all backward
      
      }
    if(x=='a'){
      //all left 2 backward right 2 forward
      
      }
    if(x=='d'){
      //all left 2 forward right 2 backward
      
      }
    if(x=='p'){
      //brake
      
    }
  }
}
